---
title: "Create a programme"
description: "\n\n### Quire permissions\n\nRequired capability: `program/manage`.\n\nCredential scopes: `programs:write`.\n\nThe acting subject must also be allowed to perform this action in the organisation."
image: "https://docs.quirelms.com/og.png"
---

> Documentation Index
> Fetch the complete documentation index at: https://docs.quirelms.com/llms.txt
> Use this file to discover all available pages before exploring further.

Path: Quire API › programs

`POST /programs`

\### Quire permissions

Required capability: `program/manage`.

Credential scopes: `programs:write`.

The acting subject must also be allowed to perform this action in the organisation.

## Authentication

Requires one of the following:

- `apiKey`, http, header `Authorization`, scopes: `programs:write`
- `oauth2`, oauth2, scopes: `programs:write`

## Header parameters

- `createProgram.header.Quire-Version` (string, optional) — The dated API revision to serve this request at. Omitted, the request is served at the revision the credential was issued against. The response echoes the revision actually applied.
  - format `date`
- `createProgram.header.Idempotency-Key` (string, optional) — A caller-chosen key making this request safe to retry. A replay of a completed request returns the recorded response with `Idempotency-Replayed: true`. Reusing a key for a different request is refused.
  - maxLength 255

## Request body

_Required._

- `createProgram.name` (string, required)
  - minLength 1; maxLength 255
- `createProgram.summary` (any of, optional)
  - any of: `string`, `null`
- `createProgram.sequencing` (string, optional) — Whether the sets have to be completed in order. Unordered when absent.
  - one of `"ordered"`, `"unordered"`
- `createProgram.enrol_on_unlock` (boolean, optional) — Enrol into a set's courses when the set unlocks rather than at assignment. True when absent.
- `createProgram.available_from` (any of, optional)
  - any of: `string`, `null`
- `createProgram.available_until` (any of, optional)
  - any of: `string`, `null`
- `createProgram.external_id` (string, optional)
  - minLength 1; maxLength 255

## Example request

```json
{
  "name": "string",
  "summary": "string",
  "sequencing": "ordered",
  "enrol_on_unlock": true,
  "available_from": "2019-08-24T14:15:22Z",
  "available_until": "2019-08-24T14:15:22Z",
  "external_id": "string"
}
```

## Code samples

### cURL

```curl
curl --request POST \
  --url https://your-organisation.quirelms.com/api/v1/programs \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "name": "string",
  "summary": "string",
  "sequencing": "ordered",
  "enrol_on_unlock": true,
  "available_from": "2019-08-24T14:15:22Z",
  "available_until": "2019-08-24T14:15:22Z",
  "external_id": "string"
}
'
```

### TypeScript

```typescript
const url = 'https://your-organisation.quirelms.com/api/v1/programs';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json', Authorization: 'Bearer <token>'},
  body: JSON.stringify({
    name: 'string',
    summary: 'string',
    sequencing: 'ordered',
    enrol_on_unlock: true,
    available_from: '2019-08-24T14:15:22Z',
    available_until: '2019-08-24T14:15:22Z',
    external_id: 'string'
  })
};

fetch(url, options)
  .then(res => res.json())
  .then(json => console.log(json))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://your-organisation.quirelms.com/api/v1/programs"

payload = {
    "name": "string",
    "summary": "string",
    "sequencing": "ordered",
    "enrol_on_unlock": True,
    "available_from": "2019-08-24T14:15:22Z",
    "available_until": "2019-08-24T14:15:22Z",
    "external_id": "string"
}
headers = {
    "Content-Type": "application/json",
    "Authorization": "Bearer <token>"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

## Responses

### 201

Success.

#### Example

```json
{
  "id": "string",
  "external_id": "string",
  "category_id": "string",
  "name": "string",
  "summary": "string",
  "sequencing": "string",
  "available_from": "string",
  "available_until": "string",
  "is_published": true,
  "created_at": "string",
  "updated_at": "string",
  "deleted_at": "string"
}
```

- `createProgram.response.201.id` (string, required)
- `createProgram.response.201.external_id` (string | null, required)
- `createProgram.response.201.category_id` (string | null, required)
- `createProgram.response.201.name` (string, required)
- `createProgram.response.201.summary` (string | null, required)
- `createProgram.response.201.sequencing` (string, required)
- `createProgram.response.201.available_from` (any of, required)
  - any of: `string`, `null`
- `createProgram.response.201.available_until` (any of, required)
  - any of: `string`, `null`
- `createProgram.response.201.is_published` (boolean, required)
- `createProgram.response.201.created_at` (string, required) — RFC 3339 timestamp in UTC.
- `createProgram.response.201.updated_at` (string, required) — RFC 3339 timestamp in UTC.
- `createProgram.response.201.deleted_at` (any of, required)
  - any of: `string`, `null`

### 401

The credential is missing, malformed, expired or revoked.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createProgram.response.401.type` (string, required)
  - format `uri`
- `createProgram.response.401.title` (string, required)
- `createProgram.response.401.status` (integer, required)
- `createProgram.response.401.code` (string, required)
- `createProgram.response.401.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createProgram.response.401.detail` (string, required)
- `createProgram.response.401.request_id` (string, required)
- `createProgram.response.401.docs_url` (string, required)
  - format `uri`
- `createProgram.response.401.errors` (array<object>, optional)
  - `createProgram.response.401.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createProgram.response.401.errors.code` (string, required)
  - `createProgram.response.401.errors.detail` (string, required)
- `createProgram.response.401.retry_after` (integer | null, optional)

### 403

The credential lacks the scope this operation requires, or the acting subject lacks the capability.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createProgram.response.403.type` (string, required)
  - format `uri`
- `createProgram.response.403.title` (string, required)
- `createProgram.response.403.status` (integer, required)
- `createProgram.response.403.code` (string, required)
- `createProgram.response.403.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createProgram.response.403.detail` (string, required)
- `createProgram.response.403.request_id` (string, required)
- `createProgram.response.403.docs_url` (string, required)
  - format `uri`
- `createProgram.response.403.errors` (array<object>, optional)
  - `createProgram.response.403.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createProgram.response.403.errors.code` (string, required)
  - `createProgram.response.403.errors.detail` (string, required)
- `createProgram.response.403.retry_after` (integer | null, optional)

### 409

The request conflicts with the current state, with a previous use of the same idempotency key, or with a concurrent write.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createProgram.response.409.type` (string, required)
  - format `uri`
- `createProgram.response.409.title` (string, required)
- `createProgram.response.409.status` (integer, required)
- `createProgram.response.409.code` (string, required)
- `createProgram.response.409.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createProgram.response.409.detail` (string, required)
- `createProgram.response.409.request_id` (string, required)
- `createProgram.response.409.docs_url` (string, required)
  - format `uri`
- `createProgram.response.409.errors` (array<object>, optional)
  - `createProgram.response.409.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createProgram.response.409.errors.code` (string, required)
  - `createProgram.response.409.errors.detail` (string, required)
- `createProgram.response.409.retry_after` (integer | null, optional)

### 422

The request was understood and its content is not valid. `errors` names each field.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createProgram.response.422.type` (string, required)
  - format `uri`
- `createProgram.response.422.title` (string, required)
- `createProgram.response.422.status` (integer, required)
- `createProgram.response.422.code` (string, required)
- `createProgram.response.422.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createProgram.response.422.detail` (string, required)
- `createProgram.response.422.request_id` (string, required)
- `createProgram.response.422.docs_url` (string, required)
  - format `uri`
- `createProgram.response.422.errors` (array<object>, optional)
  - `createProgram.response.422.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createProgram.response.422.errors.code` (string, required)
  - `createProgram.response.422.errors.detail` (string, required)
- `createProgram.response.422.retry_after` (integer | null, optional)

### 429

A rate limit or a concurrency cap was reached. `Retry-After` says when to try again.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createProgram.response.429.type` (string, required)
  - format `uri`
- `createProgram.response.429.title` (string, required)
- `createProgram.response.429.status` (integer, required)
- `createProgram.response.429.code` (string, required)
- `createProgram.response.429.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createProgram.response.429.detail` (string, required)
- `createProgram.response.429.request_id` (string, required)
- `createProgram.response.429.docs_url` (string, required)
  - format `uri`
- `createProgram.response.429.errors` (array<object>, optional)
  - `createProgram.response.429.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createProgram.response.429.errors.code` (string, required)
  - `createProgram.response.429.errors.detail` (string, required)
- `createProgram.response.429.retry_after` (integer | null, optional)

### 500

Something failed at our end. Quote `request_id` when reporting it.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createProgram.response.500.type` (string, required)
  - format `uri`
- `createProgram.response.500.title` (string, required)
- `createProgram.response.500.status` (integer, required)
- `createProgram.response.500.code` (string, required)
- `createProgram.response.500.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createProgram.response.500.detail` (string, required)
- `createProgram.response.500.request_id` (string, required)
- `createProgram.response.500.docs_url` (string, required)
  - format `uri`
- `createProgram.response.500.errors` (array<object>, optional)
  - `createProgram.response.500.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createProgram.response.500.errors.code` (string, required)
  - `createProgram.response.500.errors.detail` (string, required)
- `createProgram.response.500.retry_after` (integer | null, optional)


Source: https://docs.quirelms.com/api/programs/createProgram/index.md
